diff options
author | Jim Meyering <jim@meyering.net> | 2007-01-19 14:57:08 +0000 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2007-01-19 14:57:08 +0000 |
commit | 7987574ef6a49cc5193386579184a69546a123a0 (patch) | |
tree | 96d1a4cfd894101f2a1b9f59986f2cc09e8f6ad3 /testsuite/infloop-kawa-el | |
parent | 0f1d782e100c213ccfc262f478a4dda04695013c (diff) | |
download | idutils-7987574ef6a49cc5193386579184a69546a123a0.tar.gz idutils-7987574ef6a49cc5193386579184a69546a123a0.tar.bz2 idutils-7987574ef6a49cc5193386579184a69546a123a0.zip |
Temporary fix simply to avoid the infloop.
* libidu/scanners.c (get_token_lisp): Disable the code that
treats '[]' as part of a kawa identifier. It could call ungetc
two or three times in a row. One is the maximum.
* testsuite/infloop-kawa-el: New file. Test for the above.
* testsuite/Makefile.am (TESTS): Add infloop-kawa-el.
(TESTS_ENVIRONMENT): Prepend build directory to PATH so that
invoking e.g., "mkid" runs the just-built version of the tool.
Diffstat (limited to 'testsuite/infloop-kawa-el')
-rwxr-xr-x | testsuite/infloop-kawa-el | 58 |
1 files changed, 58 insertions, 0 deletions
diff --git a/testsuite/infloop-kawa-el b/testsuite/infloop-kawa-el new file mode 100755 index 0000000..7849e16 --- /dev/null +++ b/testsuite/infloop-kawa-el @@ -0,0 +1,58 @@ +#!/bin/sh +# This would provoke an infloop with source from 4.2+ (cvs as of 2007-01-19). + +# Copyright (C) 2007 Free Software Foundation, Inc. + +# This program is free software; you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation; either version 2 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program; if not, write to the Free Software +# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA +# 02110-1301, USA. + +if test "$VERBOSE" = yes; then + set -x + mkid --version +fi + +pwd=`pwd` +t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$ +trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0 +trap '(exit $?); exit $?' 1 2 13 15 + +framework_failure=0 +mkdir -p $tmp || framework_failure=1 +cd $tmp || framework_failure=1 +echo 'boo[! bar[]' > f.el || framework_failure=1 + +# FIXME: The expected output should probably be these two lines: +# bar +# boo[] +# but the code to handle that (now-disabled) did a double-ungetc. +cat <<EOF > exp || framework_failure=1 # expect no output +bar +boo +EOF + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + (exit 1); exit 1 +fi + +fail=0 + +mkid f.el > out || fail=1 +aid -R none b >> out || fail=1 + +cmp out exp || fail=1 +test $fail = 1 && diff out exp 2> /dev/null + +(exit $fail); exit $fail |